<div class="upload-icon">
  <input ref:uploadInput type="file" on:change="onUpload(event)" />

  <svg
    on:click="set({opened: !opened})"
    width="24"
    height="24"
    viewBox="0 0 24 24">
    <path
      fill="#b3b3b3"
      d="M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm5 11h-4v4h-2v-4H7v-2h4V7h2v4h4v2z"/>
  </svg>
  
  {#if opened}
  <div class="upload-types" transition:slide="{duration: 50}">
    <div class="upload-type" on:click="upload()">
      Upload
    </div>
    <div class="upload-type" on:click="addGame()">
      Add Game
    </div>
  </div>
  {/if}
</div>

<script>
  import GameSearchModal from "./modals/GameSearchModal.svelte";
  import slide from "svelte-transitions-slide";
  
  export default {
    transitions: {
      slide
    },
    methods: {
      addGame() {
        this.set({opened: false});
        this.store.set({
          modal: {
            component: GameSearchModal,
            listener: game => this.fire("setGame", game)
          }
        });
      },
      upload() {
        this.set({opened: false});
        this.refs.uploadInput.click();
      },
      onUpload(event) {
        console.log("Upload!", event.target.files);
        for (const file of event.target.files) {
          this.fire("fileAdd", file);
        }
        event.target.value = null;
      }
    }
  };
</script>

<style>
  svg {
    margin-bottom: 2px;
  }

  svg path {
    transition: fill ease-in-out 0.1s;
  }

  svg:hover {
    cursor: pointer;
  }

  svg:hover path {
    fill: #fff;
  }

  input {
    display: none;
  }

  .upload-icon {
    position: relative;
    display: inline-block;
  }
  .upload-types {
    position: absolute;
    bottom: 125%;
    background: #222;
    width: 500%;
    max-width: 100vw;
    border-radius: 5px;
  }

  .upload-type {
    padding: 0.5em;
    cursor: pointer;
  }

  .upload-type:hover {
    background: #333;
  }
</style>
